import QRious from 'qrious';
import Vue from 'vue';

const LEVELS = ['L', 'M', 'Q', 'H'];
var index = {
    props: {
        value: {
            type: String,
            required: true,
        },
        background: String,
        backgroundAlpha: Number,
        foreground: String,
        foregroundAlpha: Number,
        level: {
            type: String,
            validator: (level) => LEVELS.includes(level),
        },
        mime: String,
        padding: Number,
        size: Number,
    },
    data() {
        const qrious = new QRious(this.$props);
        return {
            qrious,
            dataUrl: qrious.toDataURL(this.mime),
        };
    },
    watch: {
        $props: {
            deep: true,
            handler() {
                this.qrious.set(this.$props);
                this.dataUrl = this.qrious.toDataURL(this.mime);
            },
        },
    },
    // ! hack, compatible with Vue2 and Vue3 at the same time
    render(h) {
        // @ts-expect-error
        // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment, import/namespace
        const vueH = Vue.h;
        // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
        h = vueH || h;
        const imgProps = Object.assign(Object.assign({}, this.$attrs), { src: this.dataUrl });
        // eslint-disable-next-line @typescript-eslint/no-unsafe-call, @typescript-eslint/no-unsafe-return
        return h('img', 
        // @ts-expect-error
        vueH
            ? imgProps
            : {
                domProps: imgProps,
            });
    },
};

export default index;
export { LEVELS };
