import { __assign } from "tslib";
import QRious from 'qrious';
import Vue from 'vue';
export var LEVELS = ['L', 'M', 'Q', 'H'];
export default {
    props: {
        value: {
            type: String,
            required: true,
        },
        background: String,
        backgroundAlpha: Number,
        foreground: String,
        foregroundAlpha: Number,
        level: {
            type: String,
            validator: function (level) { return LEVELS.includes(level); },
        },
        mime: String,
        padding: Number,
        size: Number,
    },
    data: function () {
        var qrious = new QRious(this.$props);
        return {
            qrious: qrious,
            dataUrl: qrious.toDataURL(this.mime),
        };
    },
    watch: {
        $props: {
            deep: true,
            handler: function () {
                this.qrious.set(this.$props);
                this.dataUrl = this.qrious.toDataURL(this.mime);
            },
        },
    },
    // ! hack, compatible with Vue2 and Vue3 at the same time
    render: function (h) {
        // @ts-expect-error
        // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment, import/namespace
        var vueH = Vue.h;
        // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
        h = vueH || h;
        var imgProps = __assign(__assign({}, this.$attrs), { src: this.dataUrl });
        // eslint-disable-next-line @typescript-eslint/no-unsafe-call, @typescript-eslint/no-unsafe-return
        return h('img', 
        // @ts-expect-error
        vueH
            ? imgProps
            : {
                domProps: imgProps,
            });
    },
};
//# sourceMappingURL=index.js.map